package loan.origination.bureaustrategy;

import loan.origination.*;
import loan.origination.Application;
import loan.origination.RequestedProduct;
import loan.origination.bureaustrategy.service.BureauStrategyClient;
import loan.origination.bureaustrategy.service.BureauStrategyRequest;
import loan.origination.bureaustrategy.service.BureauStrategyResponse;

public class BureauStrategyLauncherLambda {
	
	String endPointURL = "https://wfehda0m37.execute-api.us-east-1.amazonaws.com/test/bureau-strategy"; 
	
	BureauStrategyClient client;

	public BureauStrategyLauncherLambda() throws Exception {
		client = new BureauStrategyClient(endPointURL);
	}
	
	public BureauStrategyResponse execute(Application application, Applicant applicant, RequestedProduct requestedProduct) throws Exception {
		try {
			BureauStrategyRequest request = new BureauStrategyRequest();
	        request.setApplicant(applicant);
	        request.setApplication(application);
	        request.setRequestedProduct(requestedProduct);
	        BureauStrategyResponse response = client.execute(request);
	        String bureauStrategy = response.getApplication().getBureauStrategy();
	        application.setBureauStrategy(bureauStrategy);
	        System.out.println("Bureau Strategy: " + application.getBureauStrategy());
	        return response;
		} catch (Exception e) {
			System.out.println("ERROR executing Lambda: " + endPointURL);
			throw e;
		}
	}
    
    public static void main(String[] args) throws Exception {
        
        
    	BureauStrategyLauncherLambda launcher = new BureauStrategyLauncherLambda();
        
        Applicant[] applicants = applicantsArray.get();
        Application[] applications = applicationsArray.get();
        RequestedProduct[] requestedProducts = requestedProductsArray.get();
        
        for (int i = 0; i< applicants.length; i++) {
            System.out.println("\nTest " + i + ": " + applications[i]);
            long startTime = System.currentTimeMillis();
            BureauStrategyResponse response = launcher.execute(applications[i],applicants[i],requestedProducts[i]);
            long endTime = System.currentTimeMillis();
            System.out.println("Elapsed time: " + (endTime - startTime +1) + " ms");
        }
    }
 
}
